/*
bttravgt.c Version 0.1.0  Btree read block in traverse
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void bttravgt(btreefmt *bthdr, long ofst, blkfmt *blk)
   {
   BOOL   bResult;
   DWORD  loc;
   DWORD  rdlen;
   DWORD  msgerr;
   LPVOID lpMsgBuf;
   bthdr->reason = 0;
   loc = btseek(bthdr,ofst);
   if (bthdr->reason) return;
   bResult = ReadFile(bthdr->hndl,blk,
      (DWORD) bthdr->blksz,
      &rdlen,NULL);
   if (bResult && rdlen == (DWORD) bthdr->blksz)
      return;
   else if (!bResult)
      {
      msgerr = GetLastError();
      bthdr->reason = SYS_ERR + msgerr;
      FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
         FORMAT_MESSAGE_FROM_SYSTEM |
         FORMAT_MESSAGE_IGNORE_INSERTS,
         NULL,             /* source */
         msgerr,
         MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
         (LPTSTR) &lpMsgBuf,
         0,                /* message length */
         NULL);            /* insertion values */
      fprintf(stderr,"bttravgt: %s", lpMsgBuf);
      LocalFree(lpMsgBuf);
      fprintf(stderr,"bttravgt: %s\n",
         bthdr->dbname);
      fprintf(stderr,"bttravgt: error reading database "
	 "ofst %08x blksz %d rcdlen %d)\n",
	 ofst, bthdr->blksz, rdlen);
      fprintf(stderr,"hndl %d loc %u msgerr %d\n",
         bthdr->hndl, loc, msgerr);
      return;
      } /* read err */
   else
      {
      fprintf(stderr,"bttravgt: %s\n",
         bthdr->dbname);
      fprintf(stderr,"bttravgt: error reading database "
	 "ofst %08x blksz %d rcdlen %d)\n",
	 ofst, bthdr->blksz, rdlen);
      bthdr->reason = BTREE_ERR + 601;
      return;
      } /* read err */
   } /* bttravgt */
